import { IAnswer, IPartnerEngineConfig, IHttpResponse, IApplicationForm, IApplicationFormQuoteStartBody, ICreateApplicationFormParams, IGuestFlowConfig, IApplicationFormGuestResponse, IToken, IApplicationFormIndex, IApplicationFormQuestionSet, IQuestionSetGroup, IChoice, IFilterOptions, IChoicesRefilter, IAddQuestionPoolParams, IRemoveQuestionPoolParams, IQuoteableCarriersProduct, IQuoteRequest, IQuoteAction, IQuoteBindUrl, IAutoYear, IAutoManufacturer, IAutoModel, IAutoConfiguration, IVinConfig, VehicleFlowTypes, IAuthenticatorConfig, IUser, INewUser, ResetTokenType, ITerminalTheme, IStorefront } from '@boldpenguin/sdk-types';

declare function updateAnswer(data: Record<string, any>, answer: IAnswer, config: IPartnerEngineConfig): Promise<IHttpResponse<IAnswer>>;

declare const answer_updateAnswer: typeof updateAnswer;
declare namespace answer {
  export {
    answer_updateAnswer as updateAnswer,
  };
}

declare function getApplicationForm(id: string, config: IPartnerEngineConfig): Promise<IHttpResponse<IApplicationForm>>;
declare function getLatestApplicationForm(id: string, config: IPartnerEngineConfig): Promise<IHttpResponse<IApplicationForm>>;
declare function createExchangeApplicationForm(application: IApplicationFormQuoteStartBody, config: IPartnerEngineConfig): Promise<IHttpResponse<IApplicationForm>>;
declare function createApplicationForm(data: ICreateApplicationFormParams, config: IPartnerEngineConfig): Promise<IHttpResponse<IApplicationForm>>;
declare function cloneApplicationForm(appFormId: string, config: IPartnerEngineConfig): Promise<IHttpResponse<IApplicationForm>>;
declare function updateApplicationForm(data: Record<string, any>, appForm: IApplicationForm, config: IPartnerEngineConfig): Promise<IHttpResponse<IApplicationForm>>;
declare function deleteApplicationForm(id: string, config: IPartnerEngineConfig): Promise<IHttpResponse<IApplicationForm>>;
declare function createCurrentTierSkips(appForm: IApplicationForm, config: IPartnerEngineConfig): Promise<IHttpResponse<void>>;
declare function getTokenForAuthGuestFlow(config: IGuestFlowConfig): Promise<IHttpResponse<IApplicationFormGuestResponse>>;
/**
 * @param token_id
 * @param config
 * @returns {IToken} A single-use token to view an application form
 */
declare function getToken(token_id: string, config: IPartnerEngineConfig): Promise<IHttpResponse<IToken>>;
declare function searchApplicationForms(config: IPartnerEngineConfig, column: string, order: string, page: string, per_page: string, questions: string, q: string): Promise<IHttpResponse<[IApplicationFormIndex]>>;
declare function getApplicationFormEitScenario(id: string, config: IPartnerEngineConfig): Promise<IHttpResponse<Blob>>;

declare const applicationForm_getApplicationForm: typeof getApplicationForm;
declare const applicationForm_getLatestApplicationForm: typeof getLatestApplicationForm;
declare const applicationForm_createExchangeApplicationForm: typeof createExchangeApplicationForm;
declare const applicationForm_createApplicationForm: typeof createApplicationForm;
declare const applicationForm_cloneApplicationForm: typeof cloneApplicationForm;
declare const applicationForm_updateApplicationForm: typeof updateApplicationForm;
declare const applicationForm_deleteApplicationForm: typeof deleteApplicationForm;
declare const applicationForm_createCurrentTierSkips: typeof createCurrentTierSkips;
declare const applicationForm_getTokenForAuthGuestFlow: typeof getTokenForAuthGuestFlow;
declare const applicationForm_getToken: typeof getToken;
declare const applicationForm_searchApplicationForms: typeof searchApplicationForms;
declare const applicationForm_getApplicationFormEitScenario: typeof getApplicationFormEitScenario;
declare namespace applicationForm {
  export {
    applicationForm_getApplicationForm as getApplicationForm,
    applicationForm_getLatestApplicationForm as getLatestApplicationForm,
    applicationForm_createExchangeApplicationForm as createExchangeApplicationForm,
    applicationForm_createApplicationForm as createApplicationForm,
    applicationForm_cloneApplicationForm as cloneApplicationForm,
    applicationForm_updateApplicationForm as updateApplicationForm,
    applicationForm_deleteApplicationForm as deleteApplicationForm,
    applicationForm_createCurrentTierSkips as createCurrentTierSkips,
    applicationForm_getTokenForAuthGuestFlow as getTokenForAuthGuestFlow,
    applicationForm_getToken as getToken,
    applicationForm_searchApplicationForms as searchApplicationForms,
    applicationForm_getApplicationFormEitScenario as getApplicationFormEitScenario,
  };
}

declare function getQuestionSet(application_form: IApplicationForm, id: string, config: IPartnerEngineConfig): Promise<IHttpResponse<IApplicationFormQuestionSet>>;
declare function getQuestionSetGroups(config: IPartnerEngineConfig): Promise<IHttpResponse<IQuestionSetGroup[]>>;
declare function updateQuestionSet(data: Record<string, any>, questionSet: IApplicationFormQuestionSet, config: IPartnerEngineConfig): Promise<IHttpResponse<IApplicationFormQuestionSet>>;
declare function createQuestionSet(data: Record<string, any>, questionSet: IApplicationFormQuestionSet, config: IPartnerEngineConfig): Promise<IHttpResponse<IApplicationFormQuestionSet>>;

declare const applicationFormQuestionSet_getQuestionSet: typeof getQuestionSet;
declare const applicationFormQuestionSet_getQuestionSetGroups: typeof getQuestionSetGroups;
declare const applicationFormQuestionSet_updateQuestionSet: typeof updateQuestionSet;
declare const applicationFormQuestionSet_createQuestionSet: typeof createQuestionSet;
declare namespace applicationFormQuestionSet {
  export {
    applicationFormQuestionSet_getQuestionSet as getQuestionSet,
    applicationFormQuestionSet_getQuestionSetGroups as getQuestionSetGroups,
    applicationFormQuestionSet_updateQuestionSet as updateQuestionSet,
    applicationFormQuestionSet_createQuestionSet as createQuestionSet,
  };
}

declare function getChoices(question_id: string, config: IPartnerEngineConfig): Promise<IHttpResponse<IChoice[]>>;
declare function getChoice(id: string, config: IPartnerEngineConfig): Promise<IHttpResponse<IChoice>>;
declare function addChoice(data: Record<string, any>, config: IPartnerEngineConfig): Promise<IHttpResponse<IChoice>>;
declare function updateChoice(data: Record<string, any>, choice: Partial<IChoice>, config: IPartnerEngineConfig): Promise<IHttpResponse<IChoice>>;
declare function searchChoices(question_id: string, filterOptions: IFilterOptions, config: IPartnerEngineConfig): Promise<IHttpResponse<IChoice[]>>;
declare function searchChoicesWithNudges(question_id: string, filterOptions: IFilterOptions, config: IPartnerEngineConfig): Promise<IHttpResponse<IChoicesRefilter>>;

declare const choice_getChoices: typeof getChoices;
declare const choice_getChoice: typeof getChoice;
declare const choice_addChoice: typeof addChoice;
declare const choice_updateChoice: typeof updateChoice;
declare const choice_searchChoices: typeof searchChoices;
declare const choice_searchChoicesWithNudges: typeof searchChoicesWithNudges;
declare namespace choice {
  export {
    choice_getChoices as getChoices,
    choice_getChoice as getChoice,
    choice_addChoice as addChoice,
    choice_updateChoice as updateChoice,
    choice_searchChoices as searchChoices,
    choice_searchChoicesWithNudges as searchChoicesWithNudges,
  };
}

declare function getFeatures(config: IPartnerEngineConfig): Promise<IHttpResponse<string[]>>;

declare const features_getFeatures: typeof getFeatures;
declare namespace features {
  export {
    features_getFeatures as getFeatures,
  };
}

declare function partnerEngineUri(config: IPartnerEngineConfig): string;

declare const partnerEngineConfig_partnerEngineUri: typeof partnerEngineUri;
declare namespace partnerEngineConfig {
  export {
    partnerEngineConfig_partnerEngineUri as partnerEngineUri,
  };
}

declare function addQuestionPool({ application_id, config, question_pool_id, parent_answer_pool_id }: IAddQuestionPoolParams): Promise<IHttpResponse<boolean>>;
declare function removeQuestionPool({ application_id, config, answer_pool_id }: IRemoveQuestionPoolParams): Promise<IHttpResponse<boolean>>;

declare const questionPool_addQuestionPool: typeof addQuestionPool;
declare const questionPool_removeQuestionPool: typeof removeQuestionPool;
declare namespace questionPool {
  export {
    questionPool_addQuestionPool as addQuestionPool,
    questionPool_removeQuestionPool as removeQuestionPool,
  };
}

declare function getApplicationFormCarriersProducts(appFormId: string, config: IPartnerEngineConfig): Promise<IHttpResponse<IQuoteableCarriersProduct[]>>;

declare const carriersProduct_getApplicationFormCarriersProducts: typeof getApplicationFormCarriersProducts;
declare namespace carriersProduct {
  export {
    carriersProduct_getApplicationFormCarriersProducts as getApplicationFormCarriersProducts,
  };
}

declare function getQuoteRequests(application_id: string, config: IPartnerEngineConfig): Promise<IHttpResponse<IQuoteRequest[]>>;
declare function bindQuoteAction(action: IQuoteAction, quote: Pick<IQuoteRequest, 'id' | 'application_form_id'>, config: IPartnerEngineConfig): Promise<IHttpResponse<IQuoteBindUrl>>;
declare function bindQuote(quoteId: string, appFormId: string, config: IPartnerEngineConfig): Promise<IHttpResponse<IQuoteBindUrl>>;
declare function quoteDetails(quote: IQuoteRequest, config: IPartnerEngineConfig): Promise<IHttpResponse<IQuoteRequest>>;
declare function updateQuote(data: Record<string, any>, quote: IQuoteRequest, config: IPartnerEngineConfig): Promise<IHttpResponse<unknown>>;

declare const quoteRequest_getQuoteRequests: typeof getQuoteRequests;
declare const quoteRequest_bindQuoteAction: typeof bindQuoteAction;
declare const quoteRequest_bindQuote: typeof bindQuote;
declare const quoteRequest_quoteDetails: typeof quoteDetails;
declare const quoteRequest_updateQuote: typeof updateQuote;
declare namespace quoteRequest {
  export {
    quoteRequest_getQuoteRequests as getQuoteRequests,
    quoteRequest_bindQuoteAction as bindQuoteAction,
    quoteRequest_bindQuote as bindQuote,
    quoteRequest_quoteDetails as quoteDetails,
    quoteRequest_updateQuote as updateQuote,
  };
}

declare function getYears(config: IPartnerEngineConfig): Promise<IHttpResponse<IAutoYear[]>>;
declare function getMakes(year: number, config: IPartnerEngineConfig, options?: {
    type?: string;
    name?: string;
}): Promise<IHttpResponse<IAutoManufacturer[]>>;
declare function getModels(year: number, makeId: string, config: IPartnerEngineConfig, type?: string): Promise<IHttpResponse<IAutoModel[]>>;
declare function getConfigurations(year: number, makeId: string, modelId: string, config: IPartnerEngineConfig, type?: string): Promise<IHttpResponse<IAutoConfiguration[]>>;
declare function getVinDetails(vin: string, config: IPartnerEngineConfig): Promise<IHttpResponse<IVinConfig>>;
declare function selectVehicle(appId: string, questionGroupId: string, configurationId: string, flowType: VehicleFlowTypes, config: IPartnerEngineConfig, answerPoolId?: string, type?: string): Promise<IHttpResponse<boolean>>;

declare const vehicles_getYears: typeof getYears;
declare const vehicles_getMakes: typeof getMakes;
declare const vehicles_getModels: typeof getModels;
declare const vehicles_getConfigurations: typeof getConfigurations;
declare const vehicles_getVinDetails: typeof getVinDetails;
declare const vehicles_selectVehicle: typeof selectVehicle;
declare namespace vehicles {
  export {
    vehicles_getYears as getYears,
    vehicles_getMakes as getMakes,
    vehicles_getModels as getModels,
    vehicles_getConfigurations as getConfigurations,
    vehicles_getVinDetails as getVinDetails,
    vehicles_selectVehicle as selectVehicle,
  };
}

declare namespace index$1 {
  export {
    answer as Answer,
    applicationForm as ApplicationForm,
    applicationFormQuestionSet as ApplicationFormQuestionSet,
    choice as Choice,
    features as Features,
    partnerEngineConfig as PartnerEngineConfig,
    questionPool as QuestionPool,
    carriersProduct as QuoteableCarriersProduct,
    quoteRequest as QuoteRequest,
    vehicles as Vehicles,
  };
}

/**
 * @deprecated Signature will change, see authorizeCookieUri()
 * @param redirectUri
 * @param state
 * @param config
 * @param options
 * @returns
 */
declare function authorizeUri(redirectUri: string, state: string, config: IAuthenticatorConfig, options?: {
    provider?: string;
    inviteToken?: string;
    login_hint?: string;
}): string;
/**
 * Gets URI for login with v2 auth
 * @param redirectUri
 * @param config
 * @returns
 */
declare function authorizeCookieUri(redirectUri: string, config: IAuthenticatorConfig): string;
/**
 * @description
 * Logout path for Unified Auth and OAuth Token
 * @param config Options for which types of authentication need to be unauthenticated
 * @returns A list of requests to unauthenticate the user
 */
declare function deauthorize(config: IAuthenticatorConfig): Promise<IHttpResponse<void>[]>;
/**
 * @deprecated See authorizeCookieUri()
 */
declare function authorizeWithUserNamePassword({ config, username, password, }: {
    config: IAuthenticatorConfig;
    username: string;
    password: string;
}): Promise<IHttpResponse<IUser>>;
declare function getUser(config: IAuthenticatorConfig): Promise<IHttpResponse<IUser>>;
declare function registerUser(config: IAuthenticatorConfig, registrationDetails: INewUser): Promise<IHttpResponse<INewUser>>;
declare function forgotPassword(config: IAuthenticatorConfig, username: string): Promise<IHttpResponse<void>>;
declare function guestToken(config: IAuthenticatorConfig): Promise<IHttpResponse<IUser>>;
declare function resetPassword({ config, newPassword, token, tokenType, }: {
    config: IAuthenticatorConfig;
    newPassword: string;
    token: string;
    tokenType: ResetTokenType;
}): Promise<string>;
declare function getTerminalTheme(config: IAuthenticatorConfig): Promise<IHttpResponse<ITerminalTheme>>;
declare function getStorefrontByCode(storefrontCode: string, config: IAuthenticatorConfig): Promise<IHttpResponse<IStorefront>>;

declare const auth_authorizeUri: typeof authorizeUri;
declare const auth_authorizeCookieUri: typeof authorizeCookieUri;
declare const auth_deauthorize: typeof deauthorize;
declare const auth_authorizeWithUserNamePassword: typeof authorizeWithUserNamePassword;
declare const auth_getUser: typeof getUser;
declare const auth_registerUser: typeof registerUser;
declare const auth_forgotPassword: typeof forgotPassword;
declare const auth_guestToken: typeof guestToken;
declare const auth_resetPassword: typeof resetPassword;
declare const auth_getTerminalTheme: typeof getTerminalTheme;
declare const auth_getStorefrontByCode: typeof getStorefrontByCode;
declare namespace auth {
  export {
    auth_authorizeUri as authorizeUri,
    auth_authorizeCookieUri as authorizeCookieUri,
    auth_deauthorize as deauthorize,
    auth_authorizeWithUserNamePassword as authorizeWithUserNamePassword,
    auth_getUser as getUser,
    auth_registerUser as registerUser,
    auth_forgotPassword as forgotPassword,
    auth_guestToken as guestToken,
    auth_resetPassword as resetPassword,
    auth_getTerminalTheme as getTerminalTheme,
    auth_getStorefrontByCode as getStorefrontByCode,
  };
}

declare function authenticatorUri(config: IAuthenticatorConfig): string;

declare const authenticatorConfig_authenticatorUri: typeof authenticatorUri;
declare namespace authenticatorConfig {
  export {
    authenticatorConfig_authenticatorUri as authenticatorUri,
  };
}

declare namespace index {
  export {
    auth as Auth,
    authenticatorConfig as AuthenticatorConfig,
  };
}

export { index as Authenticator, index$1 as PartnerEngine };
